// Copyright (C) 1991-2015 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions 
// and other software and tools, and its AMPP partner logic 
// functions, and any output files from any of the foregoing 
// (including device programming or simulation files), and any 
// associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License 
// Subscription Agreement, the Altera Quartus Prime License Agreement,
// the Altera MegaCore Function License Agreement, or other 
// applicable license agreement, including, without limitation, 
// that your use is for the sole purpose of programming logic 
// devices manufactured by Altera and sold by Altera or its 
// authorized distributors.  Please refer to the applicable 
// agreement for further details.

// PROGRAM		"Quartus Prime"
// VERSION		"Version 15.1.0 Internal Build 164 08/19/2015 PN Standard Edition"
// CREATED		"Wed Sep 09 20:40:13 2015"

module a(
	reset,
	pll_select,
	pll_refclk0,
	clock,
	reconfig_write,
	reconfig_read,
	reconfig_address,
	reconfig_writedata,
	rx_bitslip,
	rx_serial_data,
	tx_enh_data_valid,
	tx_parallel_data,
	tx_serial_clk0,
	tx_serial_clkb,
	reconfig_waitrequest,
	tx_serial_clk1g,
	tx_serial_clk2g,
	reconfig_readdata,
	rx_control,
	rx_is_lockedtoref,
	rx_parallel_data,
	rx_ready,
	tx_ready,
	tx_serial_data
);


input wire	reset;
input wire	pll_select;
input wire	pll_refclk0;
input wire	clock;
input wire	reconfig_write;
input wire	reconfig_read;
input wire	[10:0] reconfig_address;
input wire	[31:0] reconfig_writedata;
input wire	[1:0] rx_bitslip;
input wire	[1:0] rx_serial_data;
input wire	[1:0] tx_enh_data_valid;
input wire	[255:0] tx_parallel_data;
input wire	[1:0] tx_serial_clk0;
input wire	[1:0] tx_serial_clkb;
output wire	reconfig_waitrequest;
output wire	tx_serial_clk1g;
output wire	tx_serial_clk2g;
output wire	[31:0] reconfig_readdata;
output wire	[39:0] rx_control;
output wire	[1:0] rx_is_lockedtoref;
output wire	[255:0] rx_parallel_data;
output wire	[1:0] rx_ready;
output wire	[1:0] tx_ready;
output wire	[1:0] tx_serial_data;

wire	[1:0] cal_busy;
wire	pll_cal_busy;
wire	pll_cal_busy1g;
wire	[1:0] pll_locked;
wire	[1:0] pll_powerdown;
wire	reconfig_clk;
wire	rst;
wire	[1:0] rx_cal_busy;
wire	[1:0] rx_clkout;
wire	[1:0] rx_is_lockedtodata;
wire	[1:0] tx_cal_busy;
wire	[1:0] tx_clkout;
wire	[1:0] SYNTHESIZED_WIRE_0;
wire	[1:0] SYNTHESIZED_WIRE_1;
wire	[1:0] SYNTHESIZED_WIRE_2;
wire	[0:35] SYNTHESIZED_WIRE_3;
wire	[1:0] SYNTHESIZED_WIRE_4;

assign	SYNTHESIZED_WIRE_3 = 0;




native1g	b2v_inst(
	.reconfig_write(reconfig_write),
	.reconfig_read(reconfig_read),
	.reconfig_clk(reconfig_clk),
	.reconfig_reset(rst),
	.rx_cdr_refclk0(pll_refclk0),
	.reconfig_address(reconfig_address),
	.reconfig_writedata(reconfig_writedata),
	.rx_analogreset(SYNTHESIZED_WIRE_0),
	.rx_bitslip(rx_bitslip),
	.rx_coreclkin(rx_clkout),
	.rx_digitalreset(SYNTHESIZED_WIRE_1),
	.rx_serial_data(rx_serial_data),
	.tx_analogreset(SYNTHESIZED_WIRE_2),
	.tx_control(SYNTHESIZED_WIRE_3),
	.tx_coreclkin(tx_clkout),
	.tx_digitalreset(SYNTHESIZED_WIRE_4),
	.tx_enh_data_valid(tx_enh_data_valid),
	.tx_parallel_data(tx_parallel_data),
	.tx_serial_clk0(tx_serial_clk0),
	.tx_serial_clk1(tx_serial_clkb),
	.reconfig_waitrequest(reconfig_waitrequest),
	.reconfig_readdata(reconfig_readdata),
	.rx_cal_busy(rx_cal_busy),
	.rx_clkout(rx_clkout),
	.rx_control(rx_control),
	.rx_is_lockedtodata(rx_is_lockedtodata),
	.rx_is_lockedtoref(rx_is_lockedtoref),
	.rx_parallel_data(rx_parallel_data),
	.tx_cal_busy(tx_cal_busy),
	.tx_clkout(tx_clkout),
	.tx_serial_data(tx_serial_data));


txpll_1g	b2v_inst1(
	.pll_powerdown(pll_powerdown[1]),
	.pll_refclk0(pll_refclk0),
	.pll_cal_busy(pll_cal_busy1g),
	.pll_locked(pll_locked[1]),
	.tx_serial_clk(tx_serial_clk1g));


reset0	b2v_inst2(
	.clock(reconfig_clk),
	.pll_select(pll_select),
	.reset(rst),
	.pll_locked(pll_locked),
	.rx_cal_busy(rx_cal_busy),
	.rx_is_lockedtodata(rx_is_lockedtodata),
	.tx_cal_busy(cal_busy),
	.pll_powerdown(pll_powerdown),
	.rx_analogreset(SYNTHESIZED_WIRE_0),
	.rx_digitalreset(SYNTHESIZED_WIRE_1),
	.rx_ready(rx_ready),
	.tx_analogreset(SYNTHESIZED_WIRE_2),
	.tx_digitalreset(SYNTHESIZED_WIRE_4),
	.tx_ready(tx_ready));


assign	cal_busy[0] = pll_cal_busy | tx_cal_busy[0] | pll_cal_busy1g;

assign	cal_busy[1] = pll_cal_busy | tx_cal_busy[1] | pll_cal_busy1g;


txpll0	b2v_inst7(
	.pll_powerdown(pll_powerdown[0]),
	.pll_refclk0(pll_refclk0),
	.tx_serial_clk(tx_serial_clk2g),
	.pll_locked(pll_locked[0]),
	.pll_cal_busy(pll_cal_busy));

assign	reconfig_clk = clock;
assign	rst = reset;

endmodule
