
# (C) 2001-2013 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 13.0 156 win32 2013.05.31.10:48:49

# ----------------------------------------
# Auto-generated simulation script

# ----------------------------------------
# Initialize the variable
if ![info exists SYSTEM_INSTANCE_NAME] { 
  set SYSTEM_INSTANCE_NAME ""
} elseif { ![ string match "" $SYSTEM_INSTANCE_NAME ] } { 
  set SYSTEM_INSTANCE_NAME "/$SYSTEM_INSTANCE_NAME"
} 

if ![info exists TOP_LEVEL_NAME] { 
  set TOP_LEVEL_NAME "a_tb"
} 

if ![info exists QSYS_SIMDIR] { 
  set QSYS_SIMDIR "./"
} 

if ![info exists QUARTUS_INSTALL_DIR] { 
  set QUARTUS_INSTALL_DIR "C:/altera/15.0faeb126/quartus/"
} 

## Set your test bench name here
##set tb_name <test bench>
set tb_name "a_tb"
if {$tb_name == ""} {
	echo "Missing test bench name: $tb_name"
}

# ----------------------------------------
# Copy ROM/RAM files to simulation directory
alias file_copy {
  echo "\[exec\] file_copy"
}

# ----------------------------------------
# Create compilation libraries
proc ensure_lib { lib } { if ![file isdirectory $lib] { vlib $lib } }
   
ensure_lib          ./libraries/     
ensure_lib          ./libraries/work/
vmap       work     ./libraries/work/
vmap       work_lib ./libraries/work

if ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] {
  ensure_lib                   ./libraries/altera_ver/       
  vmap       altera_ver        ./libraries/altera_ver/       
  ensure_lib                   ./libraries/lpm_ver/          
  vmap       lpm_ver           ./libraries/lpm_ver/          
  ensure_lib                   ./libraries/sgate_ver/        
  vmap       sgate_ver         ./libraries/sgate_ver/        
  ensure_lib                   ./libraries/altera_mf_ver/    
  vmap       altera_mf_ver     ./libraries/altera_mf_ver/    
  ensure_lib                   ./libraries/altera_lnsim_ver/ 
  vmap       altera_lnsim_ver  ./libraries/altera_lnsim_ver/ 
  ensure_lib                   ./libraries/twentynm_ver/     
  vmap       twentynm_ver      ./libraries/twentynm_ver/     
  ensure_lib                   ./libraries/twentynm_hssi_ver/
  vmap       twentynm_hssi_ver ./libraries/twentynm_hssi_ver/
  ensure_lib                   ./libraries/twentynm_hip_ver/ 
  vmap       twentynm_hip_ver  ./libraries/twentynm_hip_ver/ 
}

# Creating the library folders
# !!!! Note that may need to redo the vmap in case it got error acess libaries
ensure_lib                                     ./libraries/altera_common_sv_packages/          
vmap       altera_common_sv_packages           ./libraries/altera_common_sv_packages/          
ensure_lib                                    ./libraries/txpll0_altera_xcvr_atx_pll_a10_150/

# ----------------------------------------
# Compile device library files
alias dev_com {
  echo "\[exec\] dev_com"
  if ![ string match "*ModelSim ALTERA*" [ vsim -version ] ] {
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v"                 -work altera_ver       
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v"                          -work lpm_ver          
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v"                             -work sgate_ver        
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v"                         -work altera_mf_ver    
    vlog -sv "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv"                     -work altera_lnsim_ver 
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_atoms.v"                    -work twentynm_ver     
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/twentynm_atoms_ncrypt.v"      -work twentynm_ver     
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/twentynm_hssi_atoms_ncrypt.v" -work twentynm_hssi_ver
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_hssi_atoms.v"               -work twentynm_hssi_ver
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/mentor/twentynm_hip_atoms_ncrypt.v"  -work twentynm_hip_ver 
    vlog     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_hip_atoms.v"                -work twentynm_hip_ver 
  }
}

# ----------------------------------------
# Compile the design files in correct order
alias com {
  echo "\[exec\] com"

  # Compile Native PHY libraries
eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/altera_xcvr_native_a10_functions_h.sv"                                                       -work altera_common_sv_packages          
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_resync.sv"                                             -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_arbiter.sv"                                            -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/mentor/alt_xcvr_resync.sv"                                      -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/mentor/alt_xcvr_arbiter.sv"                                     -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/twentynm_pcs.sv"                                                -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/twentynm_pma.sv"                                                -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/twentynm_xcvr_avmm.sv"                                          -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/twentynm_xcvr_native.sv"                                        -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/mentor/twentynm_pcs.sv"                                         -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/mentor/twentynm_pma.sv"                                         -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/mentor/twentynm_xcvr_avmm.sv"                                   -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/mentor/twentynm_xcvr_native.sv"                                 -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/a10_avmm_h.sv"                                                  -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_avmm_csr.sv"                                    -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_prbs_accum.sv"                                  -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_odi_accel.sv"                                   -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_arb.sv"                                    -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/reconfig/altera_xcvr_native_a10_1g_reconfig_parameters_CFG0.sv" -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/reconfig/altera_xcvr_native_a10_1g_reconfig_parameters_CFG1.sv" -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_strm_params_jtv6obq.sv"                    -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_strm_functions.sv"                         -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_strm_ctrl.sv"                              -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/native1g_altera_xcvr_native_a10_151_jtv6obq.sv"                 -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_strm_rom_jtv6obq.sv"                       -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_strm_top_jtv6obq.sv"                       -L altera_common_sv_packages -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_native_a10_151/sim/alt_xcvr_native_rcfg_opt_logic_jtv6obq.sv"                      -L altera_common_sv_packages -work work


  # Compile ATX PLL libraries
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/twentynm_xcvr_avmm.sv"                 -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/mentor/twentynm_xcvr_avmm.sv"          -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/alt_xcvr_resync.sv"                    -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/mentor/alt_xcvr_resync.sv"             -work work
  # Duplicated, already compile at native PHY above
#  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/a10_avmm_h.sv"                         -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/alt_xcvr_native_avmm_nf.sv"            -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/altera_xcvr_atx_pll_a10.sv"            -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/a10_xcvr_atx_pll.sv"                   -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/alt_xcvr_pll_embedded_debug.sv"        -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/alt_xcvr_pll_avmm_csr.sv"              -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/mentor/altera_xcvr_atx_pll_a10.sv"     -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/mentor/a10_xcvr_atx_pll.sv"            -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/mentor/alt_xcvr_pll_embedded_debug.sv" -work work
  eval  vlog -sv "$QSYS_SIMDIR/altera_xcvr_atx_pll_a10_151/sim/mentor/alt_xcvr_pll_avmm_csr.sv"       -work work

 
 # Compile reset controller libraries

  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/altera_xcvr_functions.sv"            -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/mentor/altera_xcvr_functions.sv"     -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/alt_xcvr_resync.sv"                  -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/mentor/alt_xcvr_resync.sv"           -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/altera_xcvr_reset_control.sv"        -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/alt_xcvr_reset_counter.sv"           -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/mentor/altera_xcvr_reset_control.sv" -work work
  eval  vlog -sv  "$QSYS_SIMDIR/altera_xcvr_reset_control_151/sim/mentor/alt_xcvr_reset_counter.sv"    -work work


# compile verilog files in simulation directory
  vlog -work work  *.v
}

# Elaborate top level design
#alias elab {
#  echo "\[exec\] elab"
  #vsim -t ps -L work -L work_lib -L native0 -L txpll0 -L reset0 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L twentynm_ver -L twentynm_hssi_ver -L twentynm_hip_ver $tb_name

#  vsim -novopt -c -t ps -L work -L altera_ver -L twentynm_hssi_ver $tb_name 
#}

alias elab {
  echo "\[exec\] elab"
  eval vsim -t ps -L work -L work_lib -L altera_common_sv_packages -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L twentynm_ver -L twentynm_hssi_ver -L twentynm_hip_ver $tb_name
}

# ----------------------------------------
# Elaborate the top level design with novopt option
alias elab_debug {
  echo "\[exec\] elab_debug"
  vsim -novopt -t ps -L work -L work_lib -L native2g -L txpll0 -L reset0 -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L twentynm_ver -L twentynm_hssi_ver -L twentynm_hip_ver $tb_name
}

#-------------------------------
# run simulation
alias simulate {

#    	puts "Run simulation"
#	vsim work.$tb_name
	do wave.do
	run -all

}

# ----------------------------------------
# Compile all the design files and elaborate the top level design
alias ld "
  dev_com
  com
  elab
"

# ----------------------------------------
# Compile all the design files and elaborate the top level design with -novopt
alias ld_debug "
  dev_com
  com
  elab_debug
"

# ----------------------------------------
# Print out user commmand line aliases
alias h {
  echo "List Of Command Line Aliases"
  echo
  echo "file_copy                     -- Copy ROM/RAM files to simulation directory"
  echo
  echo "dev_com                       -- Compile device library files"
  echo
  echo "com                           -- Compile the design files in correct order"
  echo
  echo "elab                          -- Elaborate top level design"
  echo
  echo "elab_debug                    -- Elaborate the top level design with novopt option"
  echo
  echo "ld                            -- Compile all the design files and elaborate the top level design"
  echo
  echo "ld_debug                      -- Compile all the design files and elaborate the top level design with -novopt"
  echo
  echo 
  echo
  echo "List Of Variables"
  echo
  echo "TOP_LEVEL_NAME                -- Top level module name."
  echo
  echo "SYSTEM_INSTANCE_NAME          -- Instantiated system module name inside top level module."
  echo
  echo "QSYS_SIMDIR                   -- Qsys base simulation directory."
  echo
  echo "QUARTUS_INSTALL_DIR           -- Quartus installation directory."
}
file_copy
h
